=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

# Import library that includes ctxhelp.h
add_library(manual INTERFACE)
target_include_directories(manual INTERFACE "src/include")

# User manual
if(ENABLE_BUILD_DOC)
	find_package(Sphinx REQUIRED)

	set(output_dir "${CMAKE_BINARY_DIR}/share/manual/en/html")
	set(SPHINX_OUTPUT_DIRECTORY ${output_dir} PARENT_SCOPE)

	set(SPHINX_EXTENSIONS sphinx.ext.imgmath html2)
	set(SPHINX_AUTHOR "David Motl")
	sphinx_add_docs(
	  muniwin_manual
	  BUILDER html 
	  SOURCE_DIRECTORY src
	  EXTENSION_FILES "src/ext/html2.py"
	  OUTPUT_DIRECTORY ${output_dir}
	)

	set_target_properties(muniwin_manual PROPERTIES FOLDER doc)

	if(UNIX AND NOT WIN32)
		install(DIRECTORY "${output_dir}" DESTINATION "${CMUNIPACK_INSTALL_DATADIR}/manual/en")
	else(UNIX AND NOT WIN32)
		install(DIRECTORY "${output_dir}" DESTINATION "${CMAKE_INSTALL_DATADIR}/manual/en")
	endif(UNIX AND NOT WIN32)

endif(ENABLE_BUILD_DOC)
