=== toolkit/CMakeLists.txt ===
include(cmake/internal_utils.cmake)

set(toolkit_common_source 
	src/cmdline.c 
	src/cmdline.h 
	src/utils.c 
	src/utils.h 
	src/cfgfile.c 
	src/cfgfile.h
)

set(toolkit_tools
	airmass 
	autoflat 
	biasbat 
	darkbat 
	flatbat 
	helcor 
	kombine 
	konve 
	meanbias 
	meandark 
	munifind 
	munilist 
	munimatch 
	muniphot 
	timebat
)

add_library(toolkit_common OBJECT ${toolkit_common_source})
set_target_properties(toolkit_common PROPERTIES FOLDER toolkit)
target_link_libraries(toolkit_common PUBLIC libcmpack)

set(toolkit_libraries toolkit_common)

foreach(t ${toolkit_tools})
	add_toolkit_target(${t} src/${t}.c src/${t}.rc)
endforeach()
