=== muniwin/widgets/CMakeLists.txt ===
set(cmpack_widgets_public_headers
include/cmpack_chart_data.h
include/cmpack_chart_view.h
include/cmpack_curve_plot.h
include/cmpack_entity.h
include/cmpack_graph_data.h
include/cmpack_graph_view.h
include/cmpack_image_data.h
include/cmpack_preview.h
include/cmpack_scale.h
include/cmpack_time_scale_data.h
include/cmpack_time_scale_view.h
include/cmpack_widgdefs.h
include/cmpack_widgets.h
)

set(cmpack_widgets_private_headers
)

set(cmpack_widgets_sources 
${cmpack_widgets_public_headers}
${cmpack_widgets_private_headers}
src/cmpack_chart_data.cpp
src/cmpack_chart_view.cpp
src/cmpack_curve_plot.cpp
src/cmpack_entity.cpp
src/cmpack_graph_data.cpp
src/cmpack_graph_view.cpp
src/cmpack_image_data.cpp
src/cmpack_preview.cpp
src/cmpack_scale.cpp
src/cmpack_time_scale_data.cpp
src/cmpack_time_scale_view.cpp
)

set(cmpack_widgets_libraries 
libcmpack 
GTK2::gtk
)

add_library(cmpack_widgets OBJECT ${cmpack_widgets_sources})
set_target_properties(cmpack_widgets PROPERTIES FOLDER muniwin)
target_link_libraries(cmpack_widgets PUBLIC ${cmpack_widgets_libraries})
target_include_directories(cmpack_widgets PUBLIC include)
