=== thirdparty/fftpack/CMakeLists.txt ===
#
# PRIVATE HEADERS
# ---------------

set(fftpack_private_headers f2c.h)

#
# SOURCES
#
set(fftpack_sources
${fftpack_private_headers}
cfftb.c 
cfftb1.c 
cfftf.c 
cfftf1.c 
cffti.c 
cffti1.c 
cosqb.c 
cosqb1.c 
cosqf.c 
cosqf1.c 
cosqi.c 
cost.c 
costi.c 
ezfft1.c 
ezfftb.c 
ezfftf.c 
ezffti.c 
passb.c 
passb2.c 
passb3.c 
passb4.c 
passb5.c 
passf.c 
passf2.c 
passf3.c 
passf4.c 
passf5.c 
radb2.c 
radb3.c 
radb4.c 
radb5.c 
radbg.c 
radf2.c 
radf3.c 
radf4.c 
radf5.c 
radfg.c 
rfftb.c 
rfftb1.c 
rfftf.c 
rfftf1.c 
rffti.c 
rffti1.c 
sinqb.c 
sinqf.c 
sinqi.c 
sint.c 
sint1.c 
sinti.c 
)

add_library(fftpack OBJECT ${fftpack_sources})
set_target_properties(fftpack PROPERTIES FOLDER thirdparty)
set_target_properties(fftpack PROPERTIES C_STANDARD 99)
set_target_properties(fftpack PROPERTIES POSITION_INDEPENDENT_CODE ON)

if(MSVC)
    target_compile_options(fftpack PRIVATE /W3 /WX)
endif(MSVC)
