=== thirdparty/wcslib/CMakeLists.txt ===
#
# SOURCES
#
set(wcslib_sources
C/cel.c
C/dis.c
C/flexed/wcsbth.c
C/flexed/wcspih.c
C/flexed/wcsulex.c
C/flexed/wcsutrn.c
C/lin.c
C/log.c
C/prj.c
C/spc.c
C/sph.c
C/spx.c
C/tab.c
C/wcs.c
C/wcserr.c
C/wcsfix.c
C/wcshdr.c
C/wcsprintf.c
C/wcstrig.c
C/wcsunits.c
C/wcsutil.c
)

add_library(wcslib OBJECT ${wcslib_sources})
set_target_properties(wcslib PROPERTIES FOLDER thirdparty)
set_target_properties(wcslib PROPERTIES C_STANDARD 99)
set_target_properties(wcslib PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_include_directories(wcslib PUBLIC
	"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/C;${CMAKE_CURRENT_SOURCE_DIR}>"
	"$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>"
)

if(MSVC)
	target_compile_definitions(wcslib PRIVATE _CRT_SECURE_NO_DEPRECATE _CRT_SECURE_NO_WARNINGS _NO_OLDNAMES YY_NO_UNISTD_H)
	target_compile_options(wcslib PRIVATE -D__STDC__=1)
	target_compile_options(wcslib PRIVATE /W3)
	target_compile_options(wcslib PRIVATE /wd4005 /wd4244 /wd4267)
endif()

target_link_libraries(wcslib PRIVATE ${M_LIBRARY})
