=== debian/changelog ===
c-munipack (2.1.38-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standard to 4.7.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 14 Aug 2025 10:18:25 +0200
