=== debian/changelog ===
c-munipack (2.1.39-2) unstable; urgency=medium

  * disable GUI (Closes: #1052193)
    (GUI will be enabled again after upstream finished porting to GTK3)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 14 Feb 2026 18:48:26 +0100

c-munipack (2.1.39-1) unstable; urgency=medium

  * New upstream release.

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 08 Jan 2026 19:48:26 +0100
