=== debian/control ===
--- 
+++ 
@@ -10,11 +10,12 @@
 	, libexpat1-dev
 	, wcslib-dev
 	, libgstreamer1.0-dev
-	, libgtk2.0-dev
 	, doxygen
 	, libgtest-dev
 	, libgmock-dev
 	, python3-sphinx
+# no longer depend on obsolete gtk2
+#	, libgtk2.0-dev
 Standards-Version: 4.7.2
 Homepage: https://c-munipack.sourceforge.net/
 #Vcs-Browser: https://salsa.debian.org/debian/c-munipack
